--- chan_sip.c.orig	2006-01-13 15:14:13.000000000 +0100
+++ chan_sip.c	2006-01-13 15:19:20.000000000 +0100
@@ -616,6 +616,7 @@
 		AST_STRING_FIELD(subscribecontext); /*!< Subscribecontext */
 		AST_STRING_FIELD(fromdomain);	/*!< Domain to show in the from field */
 		AST_STRING_FIELD(fromuser);	/*!< User to show in the user field */
+		AST_STRING_FIELD(fromdisplayname); /*!< Displayname to show in the from field */
 		AST_STRING_FIELD(fromname);	/*!< Name to show in the user field */
 		AST_STRING_FIELD(tohost);	/*!< Host we should put in the "to" field */
 		AST_STRING_FIELD(language);	/*!< Default language for this call */
@@ -769,6 +770,7 @@
 	char regexten[AST_MAX_EXTENSION]; /*!< Extension to register (if regcontext is used) */
 	char fromuser[80];		/*!< From: user when calling this peer */
 	char fromdomain[MAXHOSTNAMELEN];	/*!< From: domain when calling this peer */
+	char fromdisplayname[80];	/*!< From: Displayname when calling this peer */
 	char fullcontact[256];		/*!< Contact registered with us (not in sip.conf) */
 	char cid_num[80];		/*!< Caller ID num */
 	char cid_name[80];		/*!< Caller ID name */
@@ -1881,6 +1883,8 @@
 		ast_string_field_set(r, fromdomain, peer->fromdomain);
 	if (!ast_strlen_zero(peer->fromuser))
 		ast_string_field_set(r, fromuser, peer->fromuser);
+	if (!ast_strlen_zero(peer->fromdisplayname))
+		ast_string_field_set(r, fromdisplayname, peer->fromdisplayname);
 	r->maxtime = peer->maxms;
 	r->callgroup = peer->callgroup;
 	r->pickupgroup = peer->pickupgroup;
@@ -4773,7 +4777,8 @@
 		snprintf(buf + strlen(buf), sizeof(buf) - strlen(buf), ";privacy=%s;screen=%s", privacy, screen);
 	ast_string_field_set(p, rpid, buf);
 
-	ast_string_field_build(p, rpid_from, "\"%s\" <sip:%s@%s>;tag=%s", clin,
+	ast_string_field_build(p, rpid_from, "\"%s\" <sip:%s@%s>;tag=%s", 
+			       ast_strlen_zero(p->fromdisplayname) ? clin : p->fromdisplayname,
 			       ast_strlen_zero(p->fromuser) ? clid : p->fromuser,
 			       fromdomain, p->tag);
 }
@@ -4840,10 +4845,10 @@
 		ast_string_field_set(p, fromuser, l);
 
 	/* Allow user to be overridden */
-	if (!ast_strlen_zero(p->fromname))
-		n = p->fromname;
+	if (!ast_strlen_zero(p->fromdisplayname))
+		n = p->fromdisplayname;
 	else /* Save for any further attempts */
-		ast_string_field_set(p, fromname, n);
+		ast_string_field_set(p, fromdisplayname, n);
 
 	if (pedanticsipchecking) {
 		ast_uri_encode(n, tmp, sizeof(tmp), 0);
@@ -8002,6 +8007,8 @@
 			ast_cli(fd, "  FromUser     : %s\n", peer->fromuser);
 		if (!ast_strlen_zero(peer->fromdomain))
 			ast_cli(fd, "  FromDomain   : %s\n", peer->fromdomain);
+                if (!ast_strlen_zero(peer->fromdisplayname))
+			ast_cli(fd, "  FromDisplayNa: %s\n", peer->fromdisplayname);
 		ast_cli(fd, "  Callgroup    : ");
 		print_group(fd, peer->callgroup, 0);
 		ast_cli(fd, "  Pickupgroup  : ");
@@ -12151,6 +12158,8 @@
 			ast_set2_flag(peer, ast_true(v->value), SIP_USEREQPHONE);
 		else if (!strcasecmp(v->name, "fromuser"))
 			ast_copy_string(peer->fromuser, v->value, sizeof(peer->fromuser));
+		else if (!strcasecmp(v->name, "fromdisplayname"))
+			ast_copy_string(peer->fromdisplayname, v->value, sizeof(peer->fromdisplayname));
 		else if (!strcasecmp(v->name, "host") || !strcasecmp(v->name, "outboundproxy")) {
 			if (!strcasecmp(v->value, "dynamic")) {
 				if (!strcasecmp(v->name, "outboundproxy") || obproxyfound) {
